from ecdsa import SigningKey,SECP256k1

# import secrets
import struct

import random
import scipy.stats as stats

def pseudoRandomGenerator(seed) :
    random.seed(seed)
    return random.getrandbits(256)

def genratePublicPrivateKey():
    sk = SigningKey.generate(curve=SECP256k1)  # uses NIST192p
    vk = sk.get_verifying_key()
    signature = sk.sign(b"message")
    assert vk.verify(signature, b"message")
    return (sk,vk)

    pass

def VRF(sk,seed,rolecount,w,badaW,pk):
    prgoutput = pseudoRandomGenerator(seed)
    temp = bytes(str(prgoutput).encode('UTF8'))
    hash = sk.sign(temp)
    proof = pk
    return (hash,proof)

def verifyVRF(pk,hash,proof,seed):
    prgoutput = pseudoRandomGenerator(seed)
    temp = bytes(str(prgoutput).encode('UTF8'))
    print(proof.verify(hash,temp))

def sortition(sk,seed,rolecount,w,badaW,pk):
    w = 25
    badaW = 100
    p = w/badaW
    j=0
    x = 0.5 # hash/(2**hashlen)
    lastValue = 0;
    print("probability : ",p)


    flag = True
    while(flag):
        lastValue = lastValue + stats.binom.pmf(j, w, p)
        nextvalue = lastValue + stats.binom.pmf(j + 1, w, p)
        print(lastValue,nextvalue)
        if (((lastValue<=x) and (nextvalue>x))):
            break
        if j == w+1:
            j=0
            break
        j = j+1

    return j


def computeRange():
    badaW=10
    lastValue = 0;
    p = 0.5
    x = 0.0023
    j = 0
    if (x<=stats.binom.pmf(0, badaW, p)):
        j = 0
    else :
        for k in range(0,badaW+1):
            lastValue = lastValue +  stats.binom.pmf(k, badaW, p)
            nextvalue =lastValue+ stats.binom.pmf(k+1, badaW, p)
            print(lastValue)
            print(nextvalue)
            print("------------")
            j =j+1



def bytes_to_int(bytes):
    result = 0
    for b in bytes:
        result = result * 256 + int(b)
    return result

def testingBinom():
    w = 1
    p=0.2
    m = 0
    for k in range(0,2):
        ev = stats.binom.pmf(k, w, p)
        m = m+ ev
        print(ev)

    print(m)

if __name__ == '__main__':
    keypair = genratePublicPrivateKey()
    #
    # # # keypair2 = genratePublicPrivateKey()
    # # # print(keypair)
    # # # print(keypair2)
    # # # print(pseudoRandomGenerator("abc"))
    # # # print(pseudoRandomGenerator("abc"))
    seed = ("abc",1,2)
    # # # print(pseudoRandomGenerator(seed))
    # x= VRF(keypair[0],seed,3,2,30,keypair[1])
    # # verifyVRF(x[1],x[0],x[1],seed)
    # # print(stats.binom.pmf(1, 2, .5))
    # print(x[0]/(2**(len(bytes_to_int(x[0])))))
    # # computeRange()
    #
    # print(bytes_to_int(x[0]))
    print(sortition(keypair[0],seed,3,2,30,keypair[1]))

    # testingBinom()
    # computeRange()